<!--
 Copyright © VNG Realisatie 2023
 Licensed under the EUPL
-->

{{ define "content" }}

    <p>
        <a href="{{ .BackButtonURLPath }}" class="button--link"
            >{{ svg "icon-chevron-left" "icon--inline" }} {{ i18n "Back" }}</a
        >
    </p>

    <section class="contract-detail-page__section">
        <div class="collapsible-container">
            <details class="collapsible">
                <summary class="collapsible__header">
                    <span>
                        {{ svg "icon-contracts" "icon--inline" }}
                        {{ i18n "Details" }}
                        {{ svg "icon-chevron-down" "icon--inline icon-collapsible" }}
                    </span>
                </summary>

                <div class="collapsible__content">
                    <p class="contract-detail-page__section-header">
                        {{ svg "icon-contracts" "icon--inline" }}
                        {{ i18n "IV" }}
                    </p>

                    <p class="contract-detail-page__section-content">
                        {{ .IV }}
                    </p>

                    <p class="contract-detail-page__section-header">
                        {{ svg "icon-code-s-slash-line" "icon--inline" }}
                        {{ i18n "Hash" }} ({{ .HashAlgorithm }})
                    </p>

                    <p class="contract-detail-page__section-content">
                        {{ .Hash }}
                    </p>

                    <p class="contract-detail-page__section-header">
                        {{ svg "icon-organization" "icon--inline" }}
                        {{ i18n "Group ID" }}
                    </p>

                    <p class="contract-detail-page__section-content">
                        {{ .GroupID }}
                    </p>
                </div>
            </details>
        </div>

        <br />

        <p class="contract-detail-page__section-header">
            {{ if .IsActive }}
                {{ svg "icon-state-active" "icon--inline" }}
                {{ i18n "State" }}
            {{ else }}
                {{ svg "icon-state-inactive" "icon--inline" }}
                {{ i18n "State" }}
            {{ end }}
        </p>

        <p class="contract-detail-page__section-content">
            {{ i18n .State }}
        </p>

        <p class="contract-detail-page__section-header">
            {{ svg "icon-time-line" "icon--inline" }}
            {{ i18n "Created At" }}
        </p>

        <p class="contract-detail-page__section-content">
            <time datetime="{{ .CreatedAt }}">
                {{ .CreatedAt }}
            </time>
        </p>

        <p class="contract-detail-page__section-header">
            {{ svg "icon-time-line" "icon--inline" }}
            {{ i18n "Validity" }}
        </p>

        <p class="contract-detail-page__section-content">
            {{ i18n "Valid from" }}
            <time datetime="{{ .ValidFrom }}">
                {{ .ValidFrom }}
            </time>
            {{ i18n "until" }}
            <time datetime="{{ .ValidUntil }}">
                {{ .ValidUntil }}
            </time>
        </p>

        <p class="contract-detail-page__section-header">
            {{ svg "icon-information-line" "icon--inline" }}
            {{ i18n "Grants" }}
        </p>

        <div class="contract-detail-page__section-content">
            {{ range $i, $grant := .ServicePublicationGrants }}
                <div
                    class="contract-detail-page__grant"
                    id="{{ $grant.HashURLFriendly }}"
                >
                    <h3 class="contract-detail-page__grant__title">
                        {{ i18n "Service Publication Grant" }}
                    </h3>
                    <small>{{ i18n "Grant Hash" }}</small><br />
                    <p class="contract-detail-page__grant__hash">
                        <span id="spg_{{ $i }}">
                            {{ $grant.Hash }}
                        </span>

                        <a
                            href="#"
                            data-copy-on-click="spg_{{ $i }}"
                            title="{{ i18n "Copy to clipboard" }}"
                        >
                            {{ svg "icon-copy" "icon icon--inline" }}
                        </a>
                    </p>
                    <p>
                        <small>{{ i18n "Directory Peer" }}</small><br />
                        {{ $grant.DirectoryPeerName }}
                        ({{ $grant.DirectoryPeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Service Peer" }}</small><br />
                        {{ $grant.ServicePeerName }}
                        ({{ $grant.ServicePeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Service Name" }}</small><br />
                        {{ $grant.ServiceName }}
                    </p>
                </div>
            {{ end }}

            {{ range $i, $grant := .ServiceConnectionGrants }}
                <div
                    class="contract-detail-page__grant"
                    id="{{ $grant.HashURLFriendly }}"
                >
                    <h3 class="contract-detail-page__grant__title">
                        {{ i18n "Service Connection Grant" }}
                    </h3>

                    <small>{{ i18n "Grant Hash" }}</small><br />
                    <p class="contract-detail-page__grant__hash">
                        <span id="scg_{{ $i }}">
                            {{ $grant.Hash }}
                        </span>

                        <a
                            href="#"
                            data-copy-on-click="scg_{{ $i }}"
                            title="{{ i18n "Copy to clipboard" }}"
                        >
                            {{ svg "icon-copy" "icon icon--inline" }}
                        </a>
                    </p>
                    <p>
                        <small>{{ i18n "Service Peer" }}</small><br />
                        {{ $grant.ServicePeerName }}
                        ({{ $grant.ServicePeerID }})
                    </p>

                    {{ if $grant.ServicePublicationDelegatorPeerID }}
                        <p>
                            <small
                                >{{ i18n "Service Publication Delegator Peer" }}</small
                            ><br />
                            {{ $grant.ServicePublicationDelegatorPeerName }}
                            ({{ $grant.ServicePublicationDelegatorPeerID }})
                        </p>
                    {{ end }}


                    <p>
                        <small>{{ i18n "Service Name" }}</small><br />
                        {{ $grant.ServiceName }}
                    </p>

                    <p>
                        <small>{{ i18n "Outway Peer" }}</small><br />
                        {{ $grant.OutwayPeerName }} ({{ $grant.OutwayPeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Outway Public Key Thumbprint" }}</small
                        ><br />
                        {{ $grant.OutwayPublicKeyThumbprint }}
                    </p>
                </div>
            {{ end }}

            {{ range $i, $grant := .DelegatedServiceConnectionGrants }}
                <div
                    class="contract-detail-page__grant"
                    id="{{ $grant.HashURLFriendly }}"
                >
                    <h3 class="contract-detail-page__grant__title">
                        {{ i18n "Delegated Service Connection Grant" }}
                    </h3>

                    <small>{{ i18n "Grant Hash" }}</small><br />
                    <p class="contract-detail-page__grant__hash">
                        <span id="dscg_{{ $i }}">
                            {{ $grant.Hash }}
                        </span>

                        <a
                            href="#"
                            data-copy-on-click="dscg_{{ $i }}"
                            title="{{ i18n "Copy to clipboard" }}"
                        >
                            {{ svg "icon-copy" "icon icon--inline" }}
                        </a>
                    </p>

                    <p>
                        <small>{{ i18n "Delegator Peer" }}</small><br />
                        {{ $grant.DelegatorPeerName }}
                        ({{ $grant.DelegatorPeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Outway Peer" }}</small><br />
                        {{ $grant.OutwayPeerName }} ({{ $grant.OutwayPeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Outway Public Key Thumbprint" }}</small
                        ><br />
                        {{ $grant.OutwayPublicKeyThumbprint }}
                    </p>

                    <p>
                        <small>{{ i18n "Service Peer" }}</small><br />
                        {{ $grant.ServicePeerName }}
                        ({{ $grant.ServicePeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Service Name" }}</small><br />
                        {{ $grant.ServiceName }}
                    </p>

                    {{ if $grant.ServicePublicationDelegatorPeerID }}
                        <p>
                            <small
                                >{{ i18n "Service Publication Delegator Peer" }}</small
                            ><br />
                            {{ $grant.ServicePublicationDelegatorPeerName }}
                            ({{ $grant.ServicePublicationDelegatorPeerID }})
                        </p>
                    {{ end }}
                </div>
            {{ end }}

            {{ range $i, $grant := .DelegatedServicePublicationGrants }}
                <div
                    class="contract-detail-page__grant"
                    id="{{ $grant.HashURLFriendly }}"
                >
                    <h3 class="contract-detail-page__grant__title">
                        {{ i18n "Delegated Service Publication Grant" }}
                    </h3>

                    <small>{{ i18n "Grant Hash" }}</small><br />

                    <p class="contract-detail-page__grant__hash">
                        <span id="dspg_{{ $i }}">
                            {{ $grant.Hash }}
                        </span>

                        <a
                            href="#"
                            data-copy-on-click="dspg_{{ $i }}"
                            title="{{ i18n "Copy to clipboard" }}"
                        >
                            {{ svg "icon-copy" "icon icon--inline" }}
                        </a>
                    </p>

                    <p>
                        <small>{{ i18n "Directory Peer" }}</small><br />
                        {{ $grant.DirectoryPeerName }}
                        ({{ $grant.DirectoryPeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Delegator Peer" }}</small><br />
                        {{ $grant.DelegatorPeerName }}
                        ({{ $grant.DelegatorPeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Service Peer" }}</small><br />
                        {{ $grant.ServicePeerName }}
                        ({{ $grant.ServicePeerID }})
                    </p>

                    <p>
                        <small>{{ i18n "Service Name" }}</small><br />
                        {{ $grant.ServiceName }}
                    </p>
                </div>
            {{ end }}
        </div>

        <br />

        <p class="contract-detail-page__section-header">
            {{ svg "icon-pen-nib-line" "icon--inline" }}
            {{ i18n "Signatures" }}
        </p>

        <div class="contract-detail-page__section-content">
            <table>
                <thead>
                    <tr>
                        <th>
                            {{ svg "icon-organization" "icon--inline" }}
                            {{ i18n "Organization" }}
                        </th>
                        <th>
                            {{ svg "icon-close-fill" "icon--inline" }}
                            {{ i18n "Rejected" }}
                        </th>
                        <th>
                            {{ svg "icon-check-fill" "icon--inline" }}
                            {{ i18n "Accepted" }}
                        </th>
                        <th>
                            {{ svg "icon-arrow-go-back-fill" "icon--inline" }}
                            {{ i18n "Revoked" }}
                        </th>
                    </tr>
                </thead>
                <tbody>
                    {{ range .Organizations }}
                        <tr>
                            <td>
                                {{ .Name }}<br />
                                <small>PeerID {{ .PeerID }}</small>
                            </td>
                            <td>
                                <time datetime="{{ .RejectSignatureSignedAt }}">
                                    {{ .RejectSignatureSignedAt }}
                                </time>
                            </td>
                            <td>
                                <time datetime="{{ .AcceptSignatureSignedAt }}">
                                    {{ .AcceptSignatureSignedAt }}
                                </time>
                            </td>
                            <td>
                                <time datetime="{{ .RevokeSignatureSignedAt }}">
                                    {{ .RevokeSignatureSignedAt }}
                                </time>
                            </td>
                        </tr>
                    {{ end }}
                </tbody>
            </table>
        </div>

        <br />

        {{ if .ShowContractDistributions }}
            <p class="contract-detail-page__section-header">
                {{ svg "icon-exchange" "icon--inline" }}
                {{ i18n "Distribution errors" }}
            </p>

            <div class="contract-detail-page__section-content">
                <table>
                    <thead>
                        <tr>
                            <th colspan="2">
                                {{ svg "icon-organization" "icon--inline" }}
                                {{ i18n "Organization" }}
                            </th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        {{ range $org := .Organizations }}
                            {{ if ne $org.PeerID $.BaseAuthenticatedPage.Peer.ID }}
                                {{ if .FailedDistribution }}
                                    <tr
                                        class="tr--link"
                                        hx-get="/contract/{{ $.Hash }}/distributions/{{ $org.PeerID }}"
                                        hx-push-url="true"
                                        hx-swap="innerHTML"
                                        hx-target="body"
                                    >
                                        <td>
                                            {{ $org.Name }}<br />
                                            <small
                                                >PeerID {{ $org.PeerID }}</small
                                            >
                                        </td>
                                        <td>
                                            <span
                                                class="contract-detail-page__distribution-warning"
                                            >
                                                {{ svg "icon-warning" "icon--inline" }}
                                                {{ i18n "One or more errors" }}
                                            </span>
                                        </td>
                                        <td class="td--link">
                                            {{ svg "icon-chevron-right" "icon" }}
                                        </td>
                                    </tr>
                                {{ end }}
                            {{ end }}
                        {{ end }}
                    </tbody>
                </table>
            </div>
        {{ end }}
    </section>

    {{ block "confirm-reject-modal" . }}{{ end }}
    {{ block "confirm-accept-modal" . }}{{ end }}
    {{ block "confirm-revoke-modal" . }}{{ end }}


    <form
        class="contract-detail-page__form"
        action="/contracts/{{ .Hash }}/sign"
        method="post"
        autocomplete="off"
    >
        <button
            type="submit"
            class="button--primary"
            name="action"
            value="reject"
            onclick="window.ConfirmRejectModal.showModal();return false;"
            {{ if .DisableRejectButton }}disabled{{ end }}
        >
            {{ i18n "Reject" }}
        </button>

        <button
            type="submit"
            class="button--primary"
            name="action"
            value="accept"
            onclick="window.ConfirmAcceptModal.showModal();return false;"
            {{ if .DisableAcceptButton }}disabled{{ end }}
        >
            {{ i18n "Accept" }}
        </button>

        <button
            type="submit"
            class="button--primary"
            name="action"
            value="revoke"
            onclick="window.ConfirmRevokeModal.showModal();return false;"
            {{ if .DisableRevokeButton }}disabled{{ end }}
        >
            {{ i18n "Revoke" }}
        </button>
    </form>
{{ end }}

{{ define "confirm-reject-modal" }}
    <dialog id="ConfirmRejectModal" class="modal">
        <div class="modal__content">
            <header class="modal__header">
                <h1 class="modal__header__title">
                    {{ i18n "Reject contract" }}
                </h1>
                <form>
                    <button
                        type="submit"
                        value="cancel"
                        formmethod="dialog"
                        class="modal__header__close"
                    >
                        {{ svg "icon-close" "modal__header__close-icon" }}
                    </button>
                </form>
            </header>
            <div class="modal__body">
                <p>
                    {{ i18n "Are you sure you want to reject this contract? This will make the Contract invalid for all involved Peers." }}
                </p>

                <form
                    class="modal__footer"
                    action="/contract/{{ .Hash }}/sign?back_button_url={{ .BackButtonURLPath }}"
                    method="post"
                >
                    <input
                        type="hidden"
                        name="csrfToken"
                        value="{{ .BaseAuthenticatedPage.CsrfToken }}"
                    />
                    <button
                        type="submit"
                        class="button--secondary"
                        formmethod="dialog"
                        autofocus
                    >
                        {{ i18n "Cancel" }}
                    </button>

                    <button
                        type="submit"
                        class="button--primary"
                        name="action"
                        value="reject"
                    >
                        {{ i18n "Reject" }}
                    </button>
                </form>
            </div>
        </div>
    </dialog>
{{ end }}

{{ define "confirm-accept-modal" }}
    <dialog id="ConfirmAcceptModal" class="modal">
        <div class="modal__content">
            <header class="modal__header">
                <h1 class="modal__header__title">
                    {{ i18n "Accept contract" }}
                </h1>
                <form>
                    <button
                        type="submit"
                        value="cancel"
                        formmethod="dialog"
                        class="modal__header__close"
                    >
                        {{ svg "icon-close" "modal__header__close-icon" }}
                    </button>
                </form>
            </header>
            <div class="modal__body">
                <p>
                    {{ i18n "Are you sure you want to accept this contract? When all involved Peers accept the contract, it will become active." }}
                </p>

                <form
                    class="modal__footer"
                    action="/contract/{{ .Hash }}/sign?back_button_url={{ .BackButtonURLPath }}"
                    method="post"
                >
                    <input
                        type="hidden"
                        name="csrfToken"
                        value="{{ .BaseAuthenticatedPage.CsrfToken }}"
                    />
                    <button
                        type="submit"
                        class="button--secondary"
                        formmethod="dialog"
                        autofocus
                    >
                        {{ i18n "Cancel" }}
                    </button>

                    <button
                        class="button--primary"
                        value="accept"
                        name="action"
                        type="submit"
                    >
                        {{ i18n "Accept" }}
                    </button>
                </form>
            </div>
        </div>
    </dialog>
{{ end }}

{{ define "confirm-revoke-modal" }}
    <dialog id="ConfirmRevokeModal" class="modal">
        <div class="modal__content">
            <header class="modal__header">
                <h1 class="modal__header__title">
                    {{ i18n "Revoke contract" }}
                </h1>
                <form>
                    <button
                        type="submit"
                        value="cancel"
                        formmethod="dialog"
                        class="modal__header__close"
                    >
                        {{ svg "icon-close" "modal__header__close-icon" }}
                    </button>
                </form>
            </header>
            <div class="modal__body">
                <p>
                    {{ i18n "Are you sure you want to revoke this contract? This will make the Contract invalid for all involved Peers." }}
                </p>

                <form
                    class="modal__footer"
                    action="/contract/{{ .Hash }}/sign?back_button_url={{ .BackButtonURLPath }}"
                    method="post"
                >
                    <input
                        type="hidden"
                        name="csrfToken"
                        value="{{ .BaseAuthenticatedPage.CsrfToken }}"
                    />
                    <button
                        type="submit"
                        class="button--secondary"
                        formmethod="dialog"
                        autofocus
                    >
                        {{ i18n "Cancel" }}
                    </button>

                    <button
                        type="submit"
                        class="button--primary"
                        value="revoke"
                        name="action"
                    >
                        {{ i18n "Revoke" }}
                    </button>
                </form>
            </div>
        </div>
    </dialog>
{{ end }}
